# See here for how this library and template was built:
#   https://gitlab.com/geekstuff.dev/templates/terraform/gitlab-managed-state/-/tree/%DC_LIB_VERSION%

include:
  # If updating the tag used in this link, you should update the tag for the default image right below
  - remote: https://gitlab.com/geekstuff.dev/templates/terraform/gitlab-managed-state/raw/%DC_LIB_VERSION%/gitlab-ci-kits/simple.prod_review.prod_manual.gitlab-ci.yml

default:
  # If updating the tag used in this image, you should update the tag for library include above
  image: registry.gitlab.com/geekstuff.dev/templates/terraform/gitlab-managed-state/gitlab-ci:%DC_LIB_VERSION%

variables:
  ## To implement by users
  # PROJECT_NAME                        # Set from main gitlab-ci file
  TF_PROJECT_NAME: tf-test-vault        # Must match TF folder name
  # VAULT_ADDR                          # Set from main gitlab-ci file

  ## To override if needed
  # DISABLE_GITLAB_STATE_CHECK: 0                   # Set to 1 to disable check and warning in safe conditions (otherwise read the warning)
  # STATE_PROJECT_ID: $CI_PROJECT_ID                # Users should use separate project for state storage if they don't want devs to read prod state
  # TF_APPLY_MANUAL: 1                              # Set to 0 to auto-apply
  # TF_STATE_NAME: ${ENV_NAME}_${TF_PROJECT_NAME}   # Can be overridden if needed
  # VAULT_NAMESPACE: default                        # Default namespace on open-source Hashicorp Vault
  # VAULT_AUTH_PATH: gitlab                         # Uses JWT auth for gitlab mounted at "gitlab" (see tf-vault-setup-manual)
  # VAULT_TRANSIT_TFPLAN_KEY: tfplan                # Uses tfplan transit key to encrypt/decrypt plan file  (see tf-vault-setup-manual)
  # VAULT_PROJECT: $PROJECT_NAME                    # Matches setup done in tf-vault-setup-manual

## Runs for all environments

.common:scripts:
  prepare:
    - export TF_VAR_abc="$(vault kv get -field=abc kv/${VAULT_PROJECT}/${ENV_NAME}/pipeline)"
    - export TF_VAR_commit_sha=$CI_COMMIT_SHA

# .common:scripts:
#   cleanup:
#     - echo "Hello"

## Per environment

# .ctx:prod:
#   variables:
#     TF_VAR_abc: my-prod-value

# .ctx:review:
#   variables:
#     TF_VAR_abc: my-review-value
